#ifndef INC_REQ_newGA
#define INC_REQ_newGA
#include "newGA.hh"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sstream>
#include <algorithm>

skeleton newGA
{
	int currentBestFitness = INT_MAX;
	// Problem ---------------------------------------------------------------

	Problem::Problem ():_cantFilas(0),_cantColumnas(0),_datosFilas(NULL),_datosColumnas(NULL), _cantGruposColumna(NULL), _cantGruposFila(NULL)
	{
        //cout << "uf6";
    }

	ostream& operator<< (ostream& os, const Problem& pbm)
	{
		os << endl << endl << "Number of Columns " << pbm._cantColumnas << endl;

		os << "Number of Rows " << pbm._cantFilas << endl;

		os<<endl;
		return os;
	}
/*
	void split(const std::string &s, char delim, Out result) 
	{
	    std::stringstream ss(s);
	    std::string item;
	    while (std::getline(ss, item, delim)) 
        {
	        *(result++) = item;
	    }
	}

	std::vector<std::string> split(const std::string &s, char delim) 
	{
	    std::vector<std::string> elems;
	    split(s, delim, std::back_inserter(elems));
	    return elems;
	}
	
	
*/

    std::string trim(std::string const& str)
    {
        std::string word;
        std::stringstream stream(str);
        stream >> word;
        return word;
    }

	istream& operator>> (istream& is, Problem& pbm)
	{

		char buffer[MAX_BUFFER];
		int i;

		//is.getline(buffer,MAX_BUFFER,'\n');
		//sscanf(buffer,"%d",&pbm._dimension);

		//CARGAR DATOS COLUMNAS
		ifstream inFile;
		inFile.open("datos_columnas");
		if (!inFile)
        {
            cerr << "Unable to open file datafile.txt";
            exit(1);   // call system to stop
        }
        /*
        string x;
        getline(inFile, x);
        pbm._cantColumnas = stoi(x);
        for(int cCol = 0; cCol < pbm._cantColumnas; cCol++)
        {
        	getline(inFile, x);
        	std::vector<std::string> divided = split(x, " ");
    		pbm._datosColumnas.push_back(divided);
    		pbm._cantGruposColumna.push_back(divided.size());
        }
        inFile.close();
        */
        
        string line2;
        getline(inFile,line2);
        line2 = trim(line2);
        pbm._cantColumnas = stoi(line2);
        cout << pbm._cantColumnas;
        for(int c = 0; c < pbm.cantColumnas(); c++)
        {
            getline(inFile, line2);
            
            std::vector<int> divided;
            
            int n = line2.length();  
            int len=1;
            int t=0;
            int z=0;
            for(int i=0; i<=line2.length(); i++) 
            {   
                //cout << line2.length() << "LENGTH LINEA 2" << endl;
                if(line2[i] == ' '|| i==line2.length()) 
                {   
                    string rr = line2.substr(z,len);
                    if (rr != "")
                    {
                        //cout << rr << "ANTES DE TRIM" << endl;
                        rr = trim(rr);
                        //cout << "columna" << c << rr << endl;
                        //cout << rr << "LUEGO DE TRIM" << endl;
                        divided.push_back(stoi(rr));
                    }
                    
                    //cout << rr << " ";
                    t=t+1;
                    z=i+1;
                    len=1;
                    //s.erase(i,1);
                }
                else len=len+1;
                
            }
            pbm._datosColumnas.push_back(divided);
            pbm._cantGruposColumna.push_back(divided.size());

        }
        inFile.close();

        //CARGAR DATOS FILAS
		ifstream inFile2;
		inFile2.open("datos_filas");
		if (!inFile2)
        {
            cerr << "Unable to open file datafile.txt";
            exit(1);   // call system to stop
        }
        
        //string line2;
        getline(inFile2,line2);
        line2 = trim(line2);
        pbm._cantFilas = stoi(line2);
        //cout << "CANT FILAS" << pbm._cantFilas << endl;
        for(int c = 0; c < pbm.cantFilas(); c++)
        {
            getline(inFile2, line2);
            
            std::vector<int> divided;
            
            int n = line2.length();  
            int len=1;
            int t=0;
            int z=0;
            for(int i=0; i<=line2.length(); i++) 
            {
                if(line2[i] == ' '|| i==line2.length()) 
                {
                    string rr = line2.substr(z,len);
                    if (rr != "")
                    {
                        //cout << rr << "ANTES DE TRIM" << endl;
                        rr = trim(rr);
                        //cout << "linea" << c << rr << endl;
                        //cout << rr << "LUEGO DE TRIM" << endl;
                        divided.push_back(stoi(rr));
                    }
                    
                    //cout << rr << " ";
                    t=t+1;
                    z=i+1;
                    len=1;
                    //s.erase(i,1);
                }
                else len=len+1;
            }
            pbm._datosFilas.push_back(divided);
            pbm._cantGruposFila.push_back(divided.size());

        }
        exit;
        inFile2.close();

		cout<<pbm;
		return is;
	}

	//Funcion para leer el archivo CSV
	const char* Problem::getfield(char* line, int num)
	{
	    const char* tok;
	    for (tok = strtok(line, ",");
	            tok && *tok;
	            tok = strtok(NULL, ",\n"))
	    {
	        if (!--num)
	            return tok;
	    }
	    return NULL;
	}


	bool Problem::operator== (const Problem& pbm) const
	{
		if (_cantColumnas != pbm.cantColumnas() || _cantFilas != pbm.cantFilas()) return false;
		return true;
	}

	bool Problem::operator!= (const Problem& pbm) const
	{
		return !(*this == pbm);
	}

	Direction Problem::direction() const
	{
		//return maximize;
		return minimize;
	}
	
	int Problem::cantColumnas() const
	{
		return _cantColumnas;
	}
	int Problem::cantFilas() const
	{
		return _cantFilas;
	}

	std::vector<std::vector<int>> Problem::datosFilas() const
	{
		return _datosFilas;
	}

	std::vector<std::vector<int>> Problem::datosColumnas() const
	{
		return _datosColumnas;
	}

	std::vector<int> Problem::cantGruposColumna() const
	{
		return _cantGruposColumna;
	}

	std::vector<int> Problem::cantGruposFila() const
	{
		return _cantGruposFila;
	}

	Problem::~Problem()
	{
		//Libero la memoria pedida para almacenar los limites de los barrios
	}

	// Solution --------------------------------------------------------------

	Solution::Solution (const Problem& pbm):_pbm(pbm)
	{
        /*
        for (int i = 0; i <pbm.cantColumnas(); i++)
        {
            Rarray<int> aux(pbm.cantFilas());
            _var[i] = aux;
        }*/
        
         
        _var = Rarray<Rarray<int>>(_pbm.cantColumnas());

        for (int x = 0; x < _pbm.cantColumnas(); x++)
        {
            //cout<<"x=" << x << endl;
            _var[x] = Rarray<int>(_pbm.cantFilas());
            for (int y = 0; y < _pbm.cantFilas(); y++)
            {
                //cout<<"y=" << y << endl;
                _var[x][y] = 0;
            }
        }
    }

	const Problem& Solution::pbm() const
	{
		return _pbm;
	}
    
   
	Solution::Solution(const Solution& sol):_pbm(sol.pbm())
	{
        _var = Rarray<Rarray<int>>(_pbm.cantColumnas());

        for (int x = 0; x < _pbm.cantColumnas(); x++)
        {
            //cout<<"x=" << x << endl;
            _var[x] = Rarray<int>(_pbm.cantFilas());
            for (int y = 0; y < _pbm.cantFilas(); y++)
            {
                //cout<<"y=" << y << endl;
                _var[x][y] = 0;
            }
        }
		*this=sol;
        /*if (_var[0][0] != 0 && _var[0][0] != 1)
        {
            cout << "cons sol" << endl;
            exit(EXIT_FAILURE);
        }*/
	}

	istream& operator>> (istream& is, Solution& sol)
	{
		for (int i=0;i<sol.pbm().cantColumnas();i++)
        {
            for (int j = 0; j<sol.pbm().cantFilas(); j++)
            {
               is >> sol._var[i][j]; 
            }
        }
			
		return is;
	}

	ostream& operator<< (ostream& os, const Solution& sol)
	{
        cout << "Empieza os << sol" << endl;
		//for (int i=0;i<sol.pbm().dimension();i++)
		//	os << " " << sol._var[i];
        stringstream ss;

        ofstream outfile("solution");

        os << endl;
        for (int fil = 0; fil < sol.pbm().cantFilas(); fil++)
        {
            for(int col = 0; col < sol.pbm().cantColumnas(); col++)
            {
                ss << sol._var[col][fil] << " ";
            }
            ss << endl;
        }

        outfile << ss.str();
        outfile.close();

        os << ss.str();
        cout << "Termina os << sol" << endl;

		return os;
	}

	NetStream& operator << (NetStream& ns, const Solution& sol)
	{
        cout << "Empieza ns << sol" << endl;
		for(int i = 0; i < sol._pbm.cantColumnas(); i++)
        {    
            for (int j=0; j<sol._pbm.cantFilas();j++)
            {
                ns << sol._var[i][j];
                
            }
        }
        cout << "Termina ns << sol" << endl;
			
		return ns;
	}

	NetStream& operator >> (NetStream& ns, Solution& sol)
	{
		for(int i = 0; i < sol._pbm.cantColumnas(); i++)
        {    
            for (int j=0; j<sol._pbm.cantFilas();j++)
            {
                ns >> sol._var[i][j];
            }
        }
	}

 	Solution& Solution::operator= (const Solution &sol)
	{
		_var=sol._var;
       /* if (_var[0][0] != 0 && _var[0][0] != 1)
        {
            cout << "=======" << endl;
            exit(EXIT_FAILURE);
        }*/
                    
		return *this;
	}

	bool Solution::operator== (const Solution& sol) const
	{
		if (sol.pbm() != _pbm) return false;
		for(int i = 0; i < _pbm.cantColumnas(); i++)
        {    
            for (int j=0; j<sol._pbm.cantFilas();j++)
            {
                if(_var[i][j] != sol._var[i][j]) return false;
            }
        }
		return true;
	}

	bool Solution::operator!= (const Solution& sol) const
	{
		return !(*this == sol);
	}

    void Solution::initialize()
    {
        //cout << "ESTOY ENTRANDO A INITIALIZE" << endl;

        _var = Rarray<Rarray<int>>(_pbm.cantColumnas());
        _init = 1;
        for (int x = 0; x < _pbm.cantColumnas(); x++)
        {
            //cout<<"x=" << x << endl;
            _var[x] = Rarray<int>(_pbm.cantFilas());
            for (int y = 0; y < _pbm.cantFilas(); y++)
            {
                //cout<<"y=" << y << endl;
                _var[x][y] = 0;
            }
        }
        //cout << "MID1" << endl;
        for (int i=0;i<_pbm.cantColumnas();i++)
        {
            int _firstPossible = 0;
            std::vector<std::vector<int>> _grupos = _pbm.datosColumnas();
            std::vector<int> _cantGruposEnColumna = _pbm.cantGruposColumna();
            /*
            cout << "Grupos en columna " << i << ": ";
            for(int j=0; j < _cantGruposEnColumna[i]; j++)
            {
                cout << _grupos[i][j] << " ";
            }
            cout << endl;
            */
            for(int j=0; j < _cantGruposEnColumna[i]; j++)
            {
                int _lastPossible = _pbm.cantFilas() - _grupos[i][j];
                for (int k=j+1; k < _cantGruposEnColumna[i]; k++)
                {
                    _lastPossible -= _grupos[i][k] + 1;
                }
                //cout << "firstPos = " << _firstPossible << endl;
                //cout << "lastPos = " << _lastPossible << endl;

                int _startPosition = rand_int(_firstPossible, _lastPossible);
                //cout << "start = " << _startPosition << endl;
                int _endPosition = _startPosition + _grupos[i][j] - 1;
                //cout << "end = " << _endPosition << endl;
                for(int c = _startPosition; c <= _endPosition; c++)
                {
                    _var[i][c] = 1;
                }

                _firstPossible = _endPosition + 2;
            }
            cout << endl;
        }
        /*
        for (int fil = 0; fil < _pbm.cantFilas(); fil++)
        {
            for(int col = 0; col < _var.size(); col++)
            {
                cout << _var[col][fil] << " ";
            }
            cout << endl;
        }
        */
        
    // cout << "ESTOY SALIENDO A INITIALIZE" << endl;
    }

	double Solution::fitness ()
	{
                //cout << "ESTOY ENTRANDO A FITNESS" << endl;
		double fitness = 0.0;
		std::vector<std::vector<int>> datosDeFilas = _pbm.datosFilas();
		std::vector<int> cantGruposDeFila = _pbm.cantGruposFila();
		for (int i=0;i<_pbm.cantFilas();i++) 
		{
			int cantSeguidos=0;
			int columna=0;
			int cantGrupos= cantGruposDeFila[i];
			int iteradorGrupos=0;
			int resultado=0; //Resultado de la diferencia entre el bloque que tiene que haber y el bloque en el juego
			int cantUnos=0;
			bool terminoBloque = true;
			while (columna < _pbm.cantColumnas()) 
			{
				if (_var[columna][i] == 1) 
				{
					cantSeguidos++;
					terminoBloque=false;
                    cantUnos++;
				} 
				else 
				{
					if (cantSeguidos > 0) 
					{
                        if (iteradorGrupos < cantGruposDeFila[i])
                        {
                            resultado= abs(datosDeFilas[i][iteradorGrupos] - cantSeguidos); //valor absoluto de la resta
                        }
						else
                        {
                            resultado = cantSeguidos;
                        }
						fitness= fitness + 1000 * resultado;
						terminoBloque=true;
						iteradorGrupos++;
						resultado=0;
					}
					cantSeguidos=0;
				}
				columna++;
				//Si se termino la columna y faltan bloques
				
			}
			if (cantSeguidos > 0) 
            {
                if (iteradorGrupos < cantGruposDeFila[i])
                {
                    resultado= abs(datosDeFilas[i][iteradorGrupos] - cantSeguidos); //valor absoluto de la resta
                }
                else
                {
                    resultado = cantSeguidos;
                }
                fitness= fitness + 1000 * resultado;
                terminoBloque=true;
                iteradorGrupos++;
                resultado=0;
            }
            if(iteradorGrupos != cantGrupos) 
            {
                int restar= abs(cantGrupos - iteradorGrupos);
                fitness= fitness + 1100*restar;
            }
            int totalUnos = 0;
            for(int j = 0; j< cantGrupos; j++)
            {
                totalUnos += datosDeFilas[i][j];
            }
			if(cantUnos != totalUnos) 
            {
                int restar= abs(totalUnos - cantUnos);
                fitness= fitness + 300*restar;
            }
		}
		extern int currentBestFitness;
		if (fitness < currentBestFitness)
		{
			currentBestFitness = fitness;
            
		}
		//cout << "FIL" << _var[0] << endl;
        //cout << "FIL" << _var[1] << endl;
		
        for (int fil = 0; fil < _pbm.cantFilas(); fil++)
        {
            for(int col = 0; col < _pbm.cantColumnas(); col++)
            {
                //cout << sol.var(col, fil) << " ";
                if (_var[col][fil] != 0 && _var[col][fil] != 1)
                {
                    cout << "fitness end" << endl;
                    //exit(EXIT_FAILURE);
                }
            }
            //cout << endl;
        }
        
		//cout << "ESTOY SALIENDO DE FITNESS" << endl;
        if (fitness == 0)
        {
            cout << "found sol lmao" << endl;
        }
		return fitness;
	}

	char *Solution::to_String() const
	{     
        cout << "EN TO STRING" << endl;
        Rarray<int> aux = Rarray<int>(0);      //Rarray<int>((_pbm.cantColumnas() + 1) * _pbm.cantFilas());
        
        /*
        for (int fil = 0; fil < _pbm.cantFilas(); fil++)
        {
            for(int col = 0; col < _pbm.cantColumnas(); col++)
            {
                //cout << sol.var(col, fil) << " ";
                if (_var[col][fil] != 0 && _var[col][fil] != 1)
                {
                    cout << "tostring begin" << endl;
                    exit(EXIT_FAILURE);
                }
            }
            //cout << endl;
        }
        
        for(int i = 0; i < _pbm.cantFilas(); i++)
        {
            for(int j = 0; j < _pbm.cantColumnas(); j++)
            {    
                cout << _var[j][i] << " ";
            }
            cout << endl;
        }
        
        
        int c = 0;
        for (int k = 0; k < _pbm.cantFilas(); k++)
        {
            aux[c] = -1;
            c++;
        }
        for(int i = 0; i < _pbm.cantColumnas(); i++)
        {
            for(int j = 0; j < _pbm.cantFilas(); j++)
            {   
//                 if (_init == 1)
//                 {
                if (i == 0)
                {
                    cout << "j=TO STRING " << j << " -> " << _var[i][j] << endl;
                }
                aux[c] = _var[i][j];
                c++;
            }
        }
        
        int h = _pbm.cantFilas();
        for(int i = 0; i < _pbm.cantColumnas(); i++)
        {
            for(int j = 0; j < _pbm.cantFilas(); j++)
            {    
                cout << aux[h] << " ";
                h++;
            }
            cout << endl;
        }
        
        for (int fil = 0; fil < _pbm.cantFilas(); fil++)
        {
            for(int col = 0; col < _pbm.cantColumnas(); col++)
            {
                //cout << sol.var(col, fil) << " ";
                if (_var[col][fil] != 0 && _var[col][fil] != 1)
                {
                    cout << "tostring end" << endl;
                    exit(EXIT_FAILURE);
                }
            }
            //cout << endl;
        }*/
        
        
        //FILE---------------------------------------------------------------------------------------------------
        
        ofstream outfile("tempsolution");

        stringstream ss;
        
        for(int col = 0; col < _pbm.cantColumnas(); col++)
        {
            for (int fil = 0; fil < _pbm.cantFilas(); fil++)
            {
                ss << _var[col][fil] << " ";
            }
            ss << endl;
        }

        outfile << ss.str();
        outfile.close();
        
        //FILE---------------------------------------------------------------------------------------------------
        
		return (char *)aux.get_first();
	}

	void Solution::to_Solution(char *_string_)
	{
        cout << "toSolution" << endl;
        /*
		int *ptr=(int *)_string_;
        Rarray<int> aux = Rarray<int>((_pbm.cantColumnas()+1) * _pbm.cantFilas());
		for (int i=0;i< (_pbm.cantColumnas() * _pbm.cantFilas());i++)
		{
			aux[i]=*ptr;
			ptr++;
		}
		
		
        int c = _pbm.cantColumnas();
        for(int i = 0; i < _pbm.cantColumnas(); i++)
        {
            for(int j = 0; j < _pbm.cantFilas(); j++)
            {
                _var[i][j] = aux[c];
                if (i == 0)
                {
                    cout << "j= " << j << " -> " << _var[i][j] << endl;
                }
                
                c++;
            }
        }*/
        
        //FILE----------------------------------------------------------------------------------------------
        
        //CARGAR DATOS FILAS
        string line2;
		ifstream inFile2;
		inFile2.open("tempsolution");
		if (!inFile2)
        {
            cerr << "Unable to open file datafile.txt";
            exit(1);   // call system to stop
        }
        
        for(int c = 0; c < _pbm.cantColumnas(); c++)
        {
            getline(inFile2, line2);
            
            //Rarray<int> divided(_pbm.cantFilas());
            
            int f = 0;
            
            int n = line2.length();  
            int len=1;
            int t=0;
            int z=0;
            for(int i=0; i<=line2.length(); i++) 
            {
                if(line2[i] == ' '|| i==line2.length()) 
                {
                    string rr = line2.substr(z,len);
                    if (rr != "")
                    {
                        rr = trim(rr);

                        //divided.push_back(stoi(rr));
                        _var[c][f] = stoi(rr);
                        f++;
                        
                    }
                    
                    //cout << rr << " ";
                    t=t+1;
                    z=i+1;
                    len=1;
                    //s.erase(i,1);
                }
                else len=len+1;
            }

        }
        exit;
        inFile2.close();
        
        //FILE----------------------------------------------------------------------------------------------
        
        /*
        for (int fil = 0; fil < _pbm.cantFilas(); fil++)
        {
            for(int col = 0; col < _pbm.cantColumnas(); col++)
            {
                //cout << sol.var(col, fil) << " ";
                if (_var[col][fil] != 0 && _var[col][fil] != 1)
                {
                    cout << "tosolution end" << endl;
                    exit(EXIT_FAILURE);
                }
            }
            //cout << endl;
        }*/
    }

	unsigned int Solution::size() const
	{
		return (_pbm.cantColumnas() * _pbm.cantFilas() * sizeof(int));
	}


    Rarray<int>& Solution::var(const int indexC)
	{
		return _var[indexC];
	}

	
	int& Solution::var(const int indexC, const int indexF)
	{
		return _var[indexC][indexF];
	}


	Rarray<Rarray<int>>& Solution::array_var()
	{
		return _var;
	}
	
	int& Solution::init()
    {
        return _init;
    }

	Solution::~Solution()
	{    /*
          cout << "ESTOY EN DESTRUCTOR" << endl;
        _var.~Rarray<Rarray<int>>();
        cout << "SALGO DEL DESTRUCTOR" << endl; */
    }

	// UserStatistics -------------------------------------------------------

	UserStatistics::UserStatistics ()
	{}

	ostream& operator<< (ostream& os, const UserStatistics& userstat)
	{
		os << "\n---------------------------------------------------------------" << endl;
		os << "                   STATISTICS OF TRIALS                   	 " << endl;
		os << "------------------------------------------------------------------" << endl;

		for (int i=0;i< userstat.result_trials.size();i++)
		{
			os << endl
			   << userstat.result_trials[i].trial
			   << "\t" << userstat.result_trials[i].best_cost_trial
			   << "\t\t" << userstat.result_trials[i].worst_cost_trial
			   << "\t\t\t" << userstat.result_trials[i].nb_evaluation_best_found_trial
			   << "\t\t\t" << userstat.result_trials[i].nb_iteration_best_found_trial
			   << "\t\t\t" << userstat.result_trials[i].time_best_found_trial
			   << "\t\t" << userstat.result_trials[i].time_spent_trial;
		}
		os << endl << "------------------------------------------------------------------" << endl;
		return os;
	}

	UserStatistics& UserStatistics::operator= (const UserStatistics& userstats)
	{
		result_trials=userstats.result_trials;
		return (*this);
	}

	void UserStatistics::update(const Solver& solver)
	{
		if( (solver.pid()!=0) || (solver.end_trial()!=true)
		  || ((solver.current_iteration()!=solver.setup().nb_evolution_steps())
		       && !terminateQ(solver.pbm(),solver,solver.setup())))
			return;

		struct user_stat *new_stat;

		if ((new_stat=(struct user_stat *)malloc(sizeof(struct user_stat)))==NULL)
			show_message(7);
		new_stat->trial         		 		 = solver.current_trial();
		new_stat->nb_evaluation_best_found_trial = solver.evaluations_best_found_in_trial();
		new_stat->nb_iteration_best_found_trial  = solver.iteration_best_found_in_trial();
		new_stat->worst_cost_trial     		 	 = solver.worst_cost_trial();
		new_stat->best_cost_trial     		 	 = solver.best_cost_trial();
		new_stat->time_best_found_trial		 	 = solver.time_best_found_trial();
		new_stat->time_spent_trial 		 		 = solver.time_spent_trial();

		result_trials.append(*new_stat);
	}

	void UserStatistics::clear()
	{
		result_trials.remove();
	}

	UserStatistics::~UserStatistics()
	{
		result_trials.remove();
	}

// Intra_operator  --------------------------------------------------------------

	Intra_Operator::Intra_Operator(const unsigned int _number_op):_number_operator(_number_op),probability(NULL)
	{}

	unsigned int Intra_Operator::number_operator() const
	{
		return _number_operator;
	}

	Intra_Operator *Intra_Operator::create(const unsigned int _number_op)
	{
		switch (_number_op)
		{
			case 0: return new Crossover;break;
			case 1: return new Mutation();break;
		}
	}

	ostream& operator<< (ostream& os, const Intra_Operator& intra)
	{
		switch (intra.number_operator())
		{
			case 0: os << (Crossover&)intra;break;
			case 1: os << (Mutation&)intra;break;
		}
		return os;
	}

	Intra_Operator::~Intra_Operator()
	{}

//  Crossover:Intra_operator -------------------------------------------------------------

	Crossover::Crossover():Intra_Operator(0)
	{
		probability = new float[1];
	}

	void Crossover::cross(Solution& sol1,Solution& sol2) const // dadas dos soluciones de la poblacion, las cruza
	{    //cout << "ESTOY ENTRANDO A CROSSOVER" << endl;
		//Usamos cruzamiento de dos puntos (2PX)
		
        int i=0;
		Rarray<Rarray<int>> aux(sol1.pbm().cantColumnas());
		aux=sol2.array_var();
        int limit=rand_int((sol1.pbm().cantColumnas()/2)+1,sol1.pbm().cantColumnas()-1);
        int limit2=rand_int(0,limit-1);

        for (i=0;i<limit2;i++)
            sol2.var(i)=sol1.var(i);
        for (i=0;i<limit2;i++)
            sol1.var(i)=aux[i];
        for (i=limit;i<sol1.pbm().cantColumnas();i++)
            sol2.var(i)=sol1.var(i);
        for (i=limit;i<sol1.pbm().cantColumnas();i++)
            sol1.var(i)=aux[i];
        
        sol1.init() = 1;
        sol2.init() = 1;
            
    //cout << "ESTOY SALIENDO DE CROSSOVER" << endl;
	}

	void Crossover::execute(Rarray<Solution*>& sols) const
	{
		for (int i=0;i+1<sols.size();i=i+2)
		 	if (rand01()<=probability[0]) cross(*sols[i],*sols[i+1]);
	}

	ostream& operator<< (ostream& os, const Crossover&  cross)
	{
		 os << "Crossover." << " Probability: "
                    << cross.probability[0]
		    << endl;
		 return os;
	}

	void Crossover::RefreshState(const StateCenter& _sc) const
	{
		_sc.set_contents_state_variable("_crossover_probability",(char *)probability,1,sizeof(float));
	}

	void Crossover::UpdateFromState(const StateCenter& _sc)
	{
		 unsigned long nbytes,length;
		 _sc.get_contents_state_variable("_crossover_probability",(char *)probability,nbytes,length);
	}

	void Crossover::setup(char line[MAX_BUFFER])
	{
		int op;
		sscanf(line," %d %f ",&op,&probability[0]);
		assert(probability[0]>=0);
	}

	Crossover::~Crossover()
	{
		delete [] probability;
	}

	//  Mutation: Sub_operator -------------------------------------------------------------

	Mutation::Mutation():Intra_Operator(1)
	{
		probability = new float[2];
	}

	/*
	void Mutation::mutate(Solution& sol) const
	{   //cout << "ESTOY ENTRANDO A MUTATION" << endl;
		std::vector<std::vector<int>> _grupos = sol.pbm().datosColumnas();
		for (int i=0;i<sol.pbm().cantColumnas();i++)
		{
			if (rand01()<=probability[1])
			{
				int inic= rand_int(0,sol.pbm().cantFilas()-2); //Arranca en 0, si tiene 15 filas va hasta la 14
				int fin= rand_int(inic+1,sol.pbm().cantFilas()-1);
				if (fin != (sol.pbm().cantFilas()-1)) {
					if (fin-inic == 1) {
						if (i != 0) {
							int aux= _grupos[i][inic-1];
							_grupos[i][inic-1] = _grupos[i][inic];
							_grupos[i][inic]= aux;
						} else {
							int aux= _grupos[i][inic+1];
							_grupos[i][inic+1] = _grupos[i][inic];
							_grupos[i][inic]= aux;
						}
					} else { //fin-inic != 1, ES UN GRUPO
						int iter=inic; //ITERADOR
						if (i != 0) { //SI ESTA ARRIBA
							int var =_grupos[i][iter-1];
							while (iter != fin+1) {
								_grupos[i][iter-1] = _grupos[i][inic];
								iter++;
							}
							_grupos[i][iter] = var;
						} else { //ESTOY EN LO MAS ARRIBA POSIBLE, LO HAGO PARA ABAJO
							if (fin != sol.pbm().cantFilas()-1) { //CHEQUEO QUE EFECTIVAMENTE ME PUEDO MOVER PARA ABAJO
								int var =_grupos[i][iter+1];
								while (iter != fin+1) {
									_grupos[i][iter+1] = _grupos[i][inic];
									iter++;
								}
								_grupos[i][iter] = var;
							}
						}
					}
				}
			}
		}
		
    //cout << "ESTOY SALIENDO DE MUTATION" << endl;
	}
*/
	void Mutation::mutate(Solution& sol) const
	{   
//         cout << "ESTOY ENTRANDO A MUTATION" << endl;

//         for (int fil = 0; fil < sol.pbm().cantFilas(); fil++)
//         {
//             for(int col = 0; col < sol.pbm().cantColumnas(); col++)
//             {
//                 cout << sol.var(col, fil) << " ";
//                 if (sol.var(col, fil) != 0 && sol.var(col, fil) != 1)
//                 {
//                     //exit(EXIT_FAILURE);
//                 }
//             }
//             cout << endl;
//         }
 		std::vector<std::vector<int>> _grupos = sol.pbm().datosColumnas();
         
         //Rarray<Rarray<int>> tempVar = sol.array_var();
 		bool didit = false;
         
//          cout << "printed sol" << endl;
         
 		for (int i=0;i<sol.pbm().cantColumnas();i++)
 		{
//             cout << "forColumnasBegin" << endl; 
 			int j = 0;
//              cout << "grupos.size() = " << _grupos[i].size() << endl;
 			for (int g=0; g<_grupos[i].size(); g++)
			{
//                  cout << "forGruposBegin" << endl; 
//                  cout << "i = " << i << endl;
//                  cout << "j = " << j << endl;
                 //cout << "sol.var(i, j) = " << sol.var(i,j) << endl;
 				while (sol.var(i, j) != 1)
 				{
 					j+= 1;
                     //cout << "sol.var(i, j) = " << sol.var(i,j) << endl;
 				}
 				//cout << "j after while = " << j << endl;
 				//cout << "here?" << endl;
 				if (rand01()<=probability[1])
 				{
 					didit = true;
                     //cout << "selectedForMutation" << endl;
                     
 					int selector = rand_int(0, 1);
					if (selector == 0)
 					{
                         //cout << "selector0Begin" << endl; 
 						if ((j-2 >= 0) && (sol.var(i, j - 2) == 0))
 						{
 							sol.var(i, j - 1) = 1;
 							sol.var(i, j + _grupos[i][g] - 1) = 0;
 							j = j + _grupos [i][g] - 1;
 						}
 						else if ((j + _grupos[i][g] + 1 < sol.pbm().cantFilas()) && (sol.var(i, j + _grupos[i][g] + 1) == 0))
 						{
 							sol.var(i, j) = 0;
 							sol.var(i, j + _grupos[i][g]) = 1;
 							j = j + _grupos [i][g] + 1;
 						}
 						//cout << "selector0End" << endl; 
 					}
 					else
 					{
                        //cout << "selector1Begin" << endl; 
 						if ((j + _grupos[i][g] + 1 < sol.pbm().cantFilas()) && (sol.var(i, j + _grupos[i][g] + 1) == 0))
 						{
 							sol.var(i, j) = 0;
 							sol.var(i, j + _grupos[i][g]) = 1;
 							j = j + _grupos [i][g] + 1;
 						}
 						else if ((j-2 >= 0) && (sol.var(i, j - 2) == 0))
 						{
 							sol.var(i, j - 1) = 1;
 							sol.var(i, j + _grupos[i][g] - 1) = 0;
 							j = j + _grupos [i][g] - 1;
 						}
 						//cout << "selector1End" << endl; 
 					}
 				}
 				else
 				{
 					j = j + _grupos[i][g];
 				}
 				
 				//cout << "forGruposEnd" << endl; 
 			}
 			
 			//cout << "forColumnasEnd" << endl; 
 		}

//  		cout << "secondPrint: " << endl;
  		for (int fil = 0; fil < sol.pbm().cantFilas(); fil++)
         {
            for(int col = 0; col < sol.pbm().cantColumnas(); col++)
            {
                //cout << sol.var(col, fil) << " ";
                if (sol.var(col, fil) != 0 && sol.var(col, fil) != 1)
                {
                    cout << "mutation end" << endl;
                    exit(EXIT_FAILURE);
                }
            }
//             cout << endl;
        }
        /*if (didit)
        {
        	exit(EXIT_FAILURE);
        }*/
        
 		
//      cout << "ESTOY SALIENDO DE MUTATION" << endl;
	}

	void Mutation::execute(Rarray<Solution*>& sols) const
	{
		for (int i=0;i<sols.size();i++)
			if(rand01() <= probability[0])	mutate(*sols[i]);
	}

	ostream& operator<< (ostream& os, const Mutation&  mutation)
	{
		os << "Mutation." << " Probability: " << mutation.probability[0]
		   << " Probability1: " << mutation.probability[1]
		   << endl;
		return os;
	}

	void Mutation::setup(char line[MAX_BUFFER])
	{
		int op;
		sscanf(line," %d %f %f ",&op,&probability[0],&probability[1]);
		assert(probability[0]>=0);
		assert(probability[1]>=0);
	}

	void Mutation::RefreshState(const StateCenter& _sc) const
	{
		_sc.set_contents_state_variable("_mutation_probability",(char *)probability,2,sizeof(probability));
	}

	void Mutation::UpdateFromState(const StateCenter& _sc)
	{
		unsigned long nbytes,length;
		_sc.get_contents_state_variable("_mutation_probability",(char *)probability,nbytes,length);
	}

	Mutation::~Mutation()
	{
		delete [] probability;
	}

// StopCondition_1 -------------------------------------------------------------------------------------

	StopCondition_1::StopCondition_1():StopCondition()
	{}

	bool StopCondition_1::EvaluateCondition(const Problem& pbm,const Solver& solver,const SetUpParams& setup)
	{
        bool fin=(currentBestFitness == 0 || (int) (solver.current_time_spent() - solver.time_best_found_trial()) > 20000000);
//         if (currentBestFitness == 0)
//         {
//             cout << "corta bien" << endl;
//             exit(EXIT_FAILURE);
//         }

        return fin;

    }

	StopCondition_1::~StopCondition_1()
	{}

	//------------------------------------------------------------------------
	// Specific methods ------------------------------------------------------
	//------------------------------------------------------------------------

	bool terminateQ (const Problem& pbm, const Solver& solver,
			 const SetUpParams& setup)
	{
		StopCondition_1 stop;
		return stop.EvaluateCondition(pbm,solver,setup);
	}
}
#endif
